<?php
/*
Plugin Name: Get Post List With Thumbnails
Plugin URI: http://www.wpworking.com/
Description:Displays a post list and custom size thumbnails(for the post 1st image), linked to each post permalink. Use as multiples widget or shortcode.
Version: 7.0.0
Author: Alvaro Neto
Author URI: http://wpworking.com/
License: GPL2
*/

/*  Copyright 2011  Alvaro Neto  (email : wpworking@wpworking.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

add_shortcode('gplt','gplt_short');

//
function gplt_short($atts, $content = null){

   extract(shortcode_atts(array(
        'orient' => 'v',
        'imgo' => false,
        'ttgo' => false,
        'dtgo' => false,
        'dtfrm' => 1,
        'categ' => '',
        'postnr' => 20,
        'linn' => 3,
        'tbwid' => 40,
        'tbhig' => 40,
		'cp' => 4,
		'cs' => 4,
		'lwt' => 1,
		'tte' => '',
		'sptb' => false,
		'tgtb' => false,
		'ordm' => 'DESC',
		'ordf' => 'ID',
		'metk' => '',
		'mett' => 'n',
		'ech' => false
    ), $atts));
	
	ob_start();			
	$gplwtres=getPostListThumbs($orient,$imgo,$ttgo,$dtgo,$dtfrm,$categ,$postnr,$linn,$divwid,$tbwid,$tbhig,$cp,$cs,$lwt,$tte,$sptb,$tgtb,$ordm,$ordf,$metk,$mett,$ech);
	echo $gplwtres;
	$gplwt_string = ob_get_contents();
	ob_end_clean();
	return $gplwt_string;
}
//
/**
 * Add FAQ and support information
 */
add_filter('plugin_row_meta', 'wp_gplwt_plugin_links', 10, 2);
function wp_gplwt_plugin_links ($links, $file)
{
    if ($file == plugin_basename(__FILE__)) {
        $links[] = '<a href="http://www.wpworking.com/">' . __('Donate', 'wp-gplwt') . '</a>';
    }
    return $links;
}
//
function gtpartrat($par,$def)
{
  // echo "par:".$par;
	if($par =='false'){       
        $par = false;
        //echo "teste:".$par;
    }
	if($par =='true'){       
        $par = true;
        //echo "teste:".$par;
    }
    if($par =='' || $par < 0){       
        $par = $def;
        //echo "teste:".$par;
    }
    //echo "teste2:".$par;
    return $par;
}
// display a list of posts with custom size thumbnails, using the post first image
function getPostListThumbs($orient='v',$imgo=false,$ttgo=false,$dtgo=false,$dtfrm=1,$categ='',$postnr=20,$linn=3,$divwid=300,$tbwid=40,$tbhig=40,$cp=4,$cs=4,$lwt=1,$tte='',$sptb=false,$tgtb=false,$ordm='',$ordf='ID',$metk='',$mett='n',$ech=true){	
    $orient = gtpartrat($orient,'v');
    $imgo = gtpartrat($imgo,false);
	$ttgo = gtpartrat($ttgo,false);
    $dtgo = gtpartrat($dtgo,false);
	$dtfrm = gtpartrat($dtfrm,1);
	$categ = gtpartrat($categ,'');
    $postnr = gtpartrat($postnr,20);
    $linn = gtpartrat($linn,3);
    $tbwid = gtpartrat($tbwid,40);
    $tbhig = gtpartrat($tbhig,40);
	$lwt = gtpartrat($lwt,1);
	$cp = gtpartrat($cp,4);
	$cs = gtpartrat($cs,4);
	$tte = gtpartrat($tte,'');
	$sptb = gtpartrat($sptb,false);
	$tgtb = gtpartrat($tgtb,false);
	$ordm = gtpartrat($ordm,'DESC');
	$ordf = gtpartrat($ordf,'ID');
	$metk = gtpartrat($metk,'');
	$mett = gtpartrat($mett,'n');
    // $categ = category name - not required
    // $postnr = number of posts you want to display - not required    
	$htmlcod = "<div id='gplwt_container'><table id='div_postlist' width='".$divwid."' cellpadding='".$cp."' cellspacing='".$cs."'>"."\n";

	if($tte!=""):
	$htmlcod .= "<tr><td colspan='".$linn."'><h3 class='widget-title'>".$tte."</h3></td></tr>"."\n";
	endif;
	$htmlcod .= "<tr>"."\n";
    //
    //if (have_posts()) :
        global $post;
        // here we check if the user has chosen a category
        if($categ!=''){
            $strquery = "numberposts=".$postnr."&category_name=". $categ;
        }
        else{
              if($metk!=''){
				$strquery = "numberposts=".$postnr."&meta_key=". $metk;
			  }
			  else{
				$strquery =  "numberposts=".$postnr;
			  }		  
        }
        //
		if($metk!=''){
			if($mett!=''){
				if($mett=='n'){
					$strquery .=  "&orderby=meta_value_num";
				}
				else{
					$strquery .=  "&orderby=meta_value";
				}
			}
			if($ordm!=''){
				$strquery .=  "&order=".$ordm;
			}
		}
		else{
			if($ordf=='random'){
				$strquery .=  "&orderby=rand";
			}
			else{
				if($ordm!=''){
					$strquery .=  "&order=".$ordm;
				}
				//
				if($ordf!=''){
					$strquery .=  "&orderby=".$ordf;
				}
			}
		}
        //echo $strquery;
        // here we get the posts
        $myposts=get_posts($strquery);
        // if we want, we can display the number of registers found
        //echo sizeof($myposts);
        $ctxtr = 0;
		switch($dtfrm){
			case 1:
				$dtdis = 'd/m/y';
			break;
			case 2:
				$dtdis = 'm/d/y';
			break;
		}
		switch($lwt){
			case 1:
				$lwdis = false;
			break;
			case 2:
				$lwdis = true;
			break;
		}
		if($tgtb):
			$tgstr = "target='_blank'";
		else:
			$tgstr = "";
		endif;
        if($myposts):
         // here we go in the loop

        foreach($myposts as $post) :
                    // getting the first image of the post to make the thumb
                    $args = array(
                        'post_type' => 'attachment',
                        'numberposts' => -1,
                        'post_status' => null,
                        'post_parent' => $post->ID
                    );
                    $attachments = get_posts($args);
                    // here we set the variable for the attachment string
                    $imgsrc = "";
                    if ($attachments):
                        // here we take the first image and break the loop
                        foreach ($attachments as $attachment) {
                             // this brings the attachment array $imgobj = wp_get_attachment_image_src($attachment->ID);
                             // if you use the line obove, you can call $imgobj[0] to get the image source
                            // you can set the thumbnail dimensions, here we use 40 x 40
                            $imgsrc = wp_get_attachment_image($attachment->ID, array($tbwid,$tbhig), $icon = false);
                            break;
                        }
                    endif;
                    // here we start to build the return html code

                    if($orient=="v"){     
                            if($ctxtr == 0){
                                $htmlcod .= "<tr>"."\n";
                            } 

							$ctxtr = $ctxtr + 1;
							// if the post has at least one image attached, we display it
                               if(!$sptb):
							    $htmlcod .= "<td valign='top'>"."\n";
									if($imgsrc!=""):                           
										$htmlcod .= "<a href='". get_permalink() ."' title='". get_the_title() ."' ".$tgstr.">"."\n";
										$htmlcod .= $imgsrc;
										$htmlcod .= "</a>"."\n";                           
									endif;
                                $htmlcod .= "</td>"."\n";
								endif;

                                /*$htmlcod .= "<td>"."\n";
                                $htmlcod .= "<a href='". get_permalink()."' title='". get_the_title() ."'>";
                                $htmlcod .= get_the_time('d/m/Y');
                                $htmlcod .= "</a>"."\n";
                                $htmlcod .= "</td>"."\n";   
                            $htmlcod .= "</tr>"."\n";     
                            $htmlcod .= "<tr>"."\n";  */  
							if($lwdis){
								$htmlcod .= "</tr><tr>"."\n";  
							}
                            if(!$imgo){           
                                $htmlcod .= "<td valign='top'>"."\n";
								if($dtgo):
								$htmlcod .= "<p>".get_the_time($dtdis)."</p>";
								endif;
								if($ttgo):
                                $htmlcod .= "<a href='". get_permalink()."' title='". get_the_title() ."' ".$tgstr.">";
                                $htmlcod .= get_the_title();
                                $htmlcod .= "</a>"."\n";
								endif;
                                $htmlcod .= "</td>"."\n";
                            }
                            $htmlcod .= "</tr><tr>"."\n";  
                    }
                    else{
                            // linn
							if($ctxtr == 0){
                                $htmlcod .= "<tr>"."\n";
                            }      
							$ctxtr = $ctxtr + 1;                      
                            $htmlcod .= "<td valign='top'>"."\n";
                            $htmlcod .= "<table cellpadding='3' cellspacing='3' border='0' width='100%'>"."\n";
                            // if the post has at least one image attached, we display it
                                $htmlcod .= "<tr>"."\n";
                                if(!$sptb):
								$htmlcod .= "<td valign='top'>"."\n";
                            		if($imgsrc!=""):  								                           
										$htmlcod .= "<a href='". get_permalink() ."' title='". get_the_title() ."' ".$tgstr.">"."\n";
										$htmlcod .= $imgsrc;
										$htmlcod .= "</a>"."\n";    
										$htmlcod .= "</td>"."\n";                       
                            		endif;
								endif;
							if($lwdis){
								$htmlcod .= "</tr><tr>"."\n";  
							}
                                /*$htmlcod .= "<td>"."\n";
                                $htmlcod .= "<a href='". get_permalink()."' title='". get_the_title() ."'>";
                                $htmlcod .= get_the_time('d/m/Y');
                                $htmlcod .= "</a>"."\n";
                                $htmlcod .= "</td>"."\n";   
                            $htmlcod .= "</tr>"."\n";     
                            $htmlcod .= "<tr>"."\n";  */   
                            if(!$imgo){  
								$htmlcod .= "<td valign='top'>"."\n";             
                                if($dtgo):
								$htmlcod .= "<p>".get_the_time($dtdis)."</p>";
								endif;
								if($ttgo):
                                $htmlcod .= "<a href='". get_permalink()."' title='". get_the_title() ."' ".$tgstr.">";
                                $htmlcod .= get_the_title();
                                $htmlcod .= "</a>"."\n";
								endif;      
								$htmlcod .= "</td>"."\n";                         
                            }
							$htmlcod .= "</td>"."\n";
                            $htmlcod .= "</tr>"."\n";
                            $htmlcod .= "</table>"."\n";
                            $htmlcod .= "</td>"."\n";
                            if($ctxtr == $linn){
                                $htmlcod .= "</tr>"."\n";
                                $ctxtr = 0;
                            }
                    }
        endforeach;
        else:
            // here goes the message, if there is no results to display
            $htmlcod = "<tr>"."\n";
            $htmlcod = "<td>"."\n";
            $htmlcod .= "No registers found."."\n";
            $htmlcod .= "</td>"."\n";
            $htmlcod .= "</tr>"."\n";
        endif;
    //endif;
        $htmlcod .= "</table></div>";
	if($ech):
    		echo $htmlcod;
	else:
		return $htmlcod;
	endif;
}

function widget_getPostListThumbs($args) {
  extract($args);
  $options = get_option("widget_getPostListThumbs");
  if (!is_array( $options ))
	{
	$options = array(
		  'orient' => '',
		  'imgo' => '',
		  'ttgo' => '',
		  'dtgo' => '',
		  'dtfrm' => '',
		  'categ' => '',
		  'postnr' => '',
		  'linn' => '',
		  'divwid' => '',
		  'tbwid' => '',
		  'tbhig'  => '',
		  'cp' => '',
		  'cs' => '',
		  'lwt' => '',
		  'tte' => '',
		  'sptb' => '',
		  'tgtb' => false,
		  'ordm' => '',
		  'ordf' => '',
		  'metk' => '',
		  'mett' => ''
		  );
  }
 //echo $before_widget;
    echo $before_title;
      echo $options['title'];
    echo $after_title;  
  echo $after_widget;
  //Our Widget Content
    getPostListThumbs($options['orient'],$options['imgo'],$options['ttgo'],$options['dtgo'],$options['dtfrm'],$options['categ'],$options['postnr'],$options['linn'],$options['divwid'],$options['tbwid'],$options['tbhig'],$options['cp'],$options['cs'],$options['lwt'],$options['tte'],$options['sptb'],$options['tgtb'],$options['metk'],$options['mett']);
}

function getPostListThumbs_control()
{
  $options = get_option("widget_getPostListThumbs");
  if (!is_array( $options ))
	{
	$options = array(     
		  'orient' => '',
		  'imgo' => '',
		  'ttgo' => '',
		  'dtgo' => '',
		  'dtfrm' => '',
		  'categ' => '',
		  'postnr' => '',
		  'linn' => '',
		  'divwid' => '',
		  'tbwid' => '',
		  'tbhig' => '',
		  'cp' => '',
		  'cs' => '',
		  'lwt' => '',
		  'tte' => '',
		  'sptb' => '',
		  'tgtb' => false,
		  'ordm' => '',
		  'ordf' => '',
		  'metk' => '',
		  'mett' => ''
		  );

  }
  if ($_POST['getPostListThumbs-Submit'])
  {
    $options['orient'] = $_POST['getPostListThumbs-WidgetOrient'];
    $options['imgo'] = $_POST['getPostListThumbs-WidgetImgo'];
	$options['ttgo'] = $_POST['getPostListThumbs-WidgetTtgo'];
	$options['dtgo'] = $_POST['getPostListThumbs-WidgetDtgo'];
	$options['dtfrm'] = $_POST['getPostListThumbs-WidgetDtfrm'];
    $options['categ'] = htmlspecialchars($_POST['getPostListThumbs-WidgetCateg']);
    $options['postnr'] = htmlspecialchars($_POST['getPostListThumbs-WidgetPostNr']);
    $options['linn'] = htmlspecialchars($_POST['getPostListThumbs-WidgetLinn']);
    $options['divwid'] = htmlspecialchars($_POST['getPostListThumbs-WidgetDivWid']);
    $options['tbwid'] = htmlspecialchars($_POST['getPostListThumbs-WidgetTbWid']);
    $options['tbhig'] = htmlspecialchars($_POST['getPostListThumbs-WidgetTbHig']);
	$options['cp'] = $_POST['getPostListThumbs-WidgetCp'];
	$options['cs'] = $_POST['getPostListThumbs-WidgetCs'];
	$options['lwt'] = $_POST['getPostListThumbs-WidgetLwt'];
	$options['tte'] = htmlspecialchars($_POST['getPostListThumbs-WidgetTte']);
	$options['sptb'] = htmlspecialchars($_POST['getPostListThumbs-WidgetSptb']);
	$options['tgtb'] = htmlspecialchars($_POST['getPostListThumbs-WidgetTgtb']);	
	$options['tgtb'] = htmlspecialchars($_POST['getPostListThumbs-WidgetTgtb']);
	$options['ordm'] = htmlspecialchars($_POST['getPostListThumbs-WidgetOrdm']);
	$options['ordf'] = htmlspecialchars($_POST['getPostListThumbs-WidgetOrdf']);
	$options['metk'] = $_POST['getPostListThumbs-WidgetMetK'];
	$options['mett'] = $_POST['getPostListThumbs-WidgetMetT'];

    update_option("widget_getPostListThumbs", $options);
  }
?>
  <p>
    <?php
        //          
        if($options['orient']=="h"){
            $vchk = "";
            $hchk = "checked";
        }
        else{
            $vchk = "checked";
            $hchk = "";
        }
		//
        if($options['dtfrm']==2){
            $d1chk = "";
            $d2chk = "checked";
        }
        else{
            $d1chk = "checked";
            $d2chk = "";
        }
       //
        if($options['imgo']){
            $ichk = "checked";
        }
        else{
            $ichk = "";
        }
		//
        if($options['ttgo']){
            $tchk = "checked";
        }
        else{
            $tchk = "";
        }
		//
        if($options['dtgo']){
            $dchk = "checked";
        }
        else{
            $dchk = "";
        }
		//
        if($options['lwt']==2){
            $l1chk = "";
            $l2chk = "checked";
        }
		 else{
            $l1chk = "checked";
            $l2chk = "";
        }
		//
        if($options['sptb']){
            $schk = "checked";
        }
        else{
            $schk = "";
        }
		//
        if($options['tgtb']){
            $kchk = "checked";
        }
        else{
            $kchk = "";
        }
		//          
        if($options['ordm']=="ASC"){
            $omachk = "checked";
            $omdchk = "";
        }
        else{
            $omachk = "";
            $omdchk = "checked";

        }
		//
		$ordfi="";
		$ordfd="";
		$ordft="";
		$ordfr="";
		if($options['ordf']=="ID"){
			$ordfi="selected";
		}
		if($options['ordf']=="post_date"){
			$ordfd="selected";
		}
		if($options['ordf']=="title"){
			$ordft="selected";
		}
		if($options['ordf']=="random"){
			$ordfr="selected";
		}
		//          
        if($options['mett']=="t"){
            $mschk = "checked";
            $mnchk = "";
        }
        else{
            $mschk = "";
            $mnchk = "checked";
        }
		//
    ?>
    <label for="getPostListThumbs-WidgetTte">Title: </label><br />
    <input type="text" id="getPostListThumbs-WidgetTte" name="getPostListThumbs-WidgetTte" value="<?php echo $options['tte'];?>" />
    <br /><br />
    <label for="getPostListThumbs-WidgetOrient">Orientation: </label><br />
    <input type="radio" id="getPostListThumbs-WidgetOrient" name="getPostListThumbs-WidgetOrient" value="v" <?=$vchk?> />Vertical 
     <input type="radio" id="getPostListThumbs-WidgetOrient" name="getPostListThumbs-WidgetOrient" value="h" <?=$hchk?>/>Horizontal     
    <br /><br />
    <label for="getPostListThumbs-WidgetSptb">Suppress Thumbnails: </label><br />
    <input type="checkbox" id="getPostListThumbs-WidgetSptb" name="getPostListThumbs-WidgetSptb"  <?=$schk?> />
    <br /><br />
    <label for="getPostListThumbs-WidgetImgo">Display only images: </label><br />
    <input type="checkbox" id="getPostListThumbs-WidgetImgo" name="getPostListThumbs-WidgetImgo"  <?=$ichk?> />
    <br /><br />
    <label for="getPostListThumbs-WidgetDtgo">Display post date: </label><br />
    <input type="checkbox" id="getPostListThumbs-WidgetDtgo" name="getPostListThumbs-WidgetDtgo"  <?=$dchk?> />
    <br /><br />
    <label for="getPostListThumbs-WidgetDtfrm">Date Format: </label><br />
     <input type="radio" id="getPostListThumbs-WidgetDtfrm" name="getPostListThumbs-WidgetDtfrm" value="1" <?=$d1chk?>/>d/m/y
    <input type="radio" id="getPostListThumbs-WidgetDtfrm" name="getPostListThumbs-WidgetDtfrm" value="2" <?=$d2chk?> />m/d/y
    <br /><br />
    <label for="getPostListThumbs-WidgetTtgo">Display post title: </label><br />
    <input type="checkbox" id="getPostListThumbs-WidgetTtgo" name="getPostListThumbs-WidgetTtgo"  <?=$tchk?> />
    <br /><br />
    <label for="getPostListThumbs-WidgetCateg">Category Name(blank for all categories): </label><br />
    <input type="text" id="getPostListThumbs-WidgetCateg" name="getPostListThumbs-WidgetCateg" value="<?php echo $options['categ'];?>" />
	<br /><br />
    <label for="getPostListThumbs-WidgetMetK">Custom Field Key: </label><br />
    <input type="text" id="getPostListThumbs-WidgetMetK" name="getPostListThumbs-WidgetMetK" value="<?php echo $options['metk'];?>" />
    <br /><br />
    <label for="getPostListThumbs-WidgetMetT">Custom Field Values Type: </label><br />
    <input type="radio" id="getPostListThumbs-WidgetMetT" name="getPostListThumbs-WidgetMetT" value="n" <?=$mnchk?>/>Numbers
	<input type="radio" id="getPostListThumbs-WidgetMetT" name="getPostListThumbs-WidgetMetT" value="t" <?=$mschk?> />Text 
	<br /><br />
    <label for="getPostListThumbs-WidgetPostNr">Number of Posts(default=20): </label><br />
    <input type="text" id="getPostListThumbs-WidgetPostNr" name="getPostListThumbs-WidgetPostNr" value="<?php echo $options['postnr'];?>" size="4"/>
	<br /><br />
    <label for="getPostListThumbs-WidgetOrdm">Order: </label><br />
    <input type="radio" id="getPostListThumbs-WidgetOrdm" name="getPostListThumbs-WidgetOrdm" value="DESC" <?=$omdchk?>/>DESC
	<input type="radio" id="getPostListThumbs-WidgetOrdm" name="getPostListThumbs-WidgetOrdm" value="ASC" <?=$omachk?> />ASC 
	<br /><br />
    <label for="getPostListThumbs-WidgetOrdf">Order By: </label><br />
    <select id="getPostListThumbs-WidgetOrdf" name="getPostListThumbs-WidgetOrdf">
		<option value="ID" <?=$ordfi?>>ID</option>
		<option value="post_date" <?=$ordfd?>>Date</option>
		<option value="title" <?=$ordft?>>Title</option>
        <option value="random" <?=$ordfr?>>Random</option>
	</select>
   <br /><br />
    <label for="getPostListThumbs-WidgetTgtb">Target links to a blank page/tab: </label><br />
    <input type="checkbox" id="getPostListThumbs-WidgetTgtb" name="getPostListThumbs-WidgetTgtb"  <?=$schk?> />
    <br /><br />
    <label for="getPostListThumbs-WidgetLinn">Number of registers per line(default=3 only for horizontal orientation): </label><br />
    <input type="text" id="getPostListThumbs-WidgetLinn" name="getPostListThumbs-WidgetLinn" value="<?php echo $options['linn'];?>" size="4"/>
   <br />
    <label for="getPostListThumbs-WidgetDivWid">Result Table Width(default=300): </label><br />
    <input type="text" id="getPostListThumbs-WidgetDivWid" name="getPostListThumbs-WidgetDivWid" value="<?php echo $options['divwid'];?>" size="4"/>
    <br />
    <br />
    <label for="getPostListThumbs-WidgetCp">Result Table Cellpadding(default=4): </label><br />
    <input type="text" id="getPostListThumbs-WidgetCp" name="getPostListThumbs-WidgetCp" value="<?php echo $options['cp'];?>" size="4"/>
    <br />
    <label for="getPostListThumbs-WidgetCs">Result Table Cellspacing(default=4): </label><br />
    <input type="text" id="getPostListThumbs-WidgetCs" name="getPostListThumbs-WidgetCs" value="<?php echo $options['cs'];?>" size="4"/>
    <br />
    <label for="getPostListThumbs-WidgetTbWid">Thumbnails Width(default=40): </label><br />
    <input type="text" id="getPostListThumbs-WidgetTbWid" name="getPostListThumbs-WidgetTbWid" value="<?php echo $options['tbwid'];?>" size="4"/>
    <br />
    <label for="getPostListThumbs-WidgetTbHig">Thumbnails Height(default=40): </label><br />
    <input type="text" id="getPostListThumbs-WidgetTbHig" name="getPostListThumbs-WidgetTbHig" value="<?php echo $options['tbhig'];?>" size="4"/>
    <br />
    <label for="getPostListThumbs-WidgetDtfrm">Column Layout: </label><br />
    <table cellpadding="0" cellspacing="3">
     <tr>
		<td valign="top"><input type="radio" id="getPostListThumbs-WidgetLwt" name="getPostListThumbs-WidgetLwt" value="1" <?=$l1chk?>/></td><td><table cellpadding="0" cellspacing="3" style="border:0px #666 solid"><tr><td style="border:1px #666 solid">Image</td><td style="border:1px #666 solid"><p>Date</p>Title</td></tr></table></td>
		<td valign="top"><input type="radio" id="getPostListThumbs-WidgetLwt" name="getPostListThumbs-WidgetLwt" value="2" <?=$l2chk?> /></td><td><table cellpadding="0" cellspacing="3" border="1" style="border:0px #666 solid"><tr><td style="border:1px #666 solid">Image</td></tr><tr><td style="border:1px #666 solid"><p>Date</p>Title</td></tr></table></td>
    </tr>
    </table>
    <input type="hidden" id="getPostListThumbs-Submit" name="getPostListThumbs-Submit" value="1" />
  </p>
<?php
}
//error_reporting(E_ALL);
//ini_set('display_errors', '1');
function getPostListThumbs_init()
{
 // register_sidebar_widget(__('Get Post List With Thumbnails'), 'widget_getPostListThumbs'); 
 // register_widget_control(   'Get Post List With Thumbnails', 'getPostListThumbs_control', 300, 240 );
 //register_widget('GPLWT_Widget');
}
add_action("plugins_loaded", "getPostListThumbs_init");
add_action('widgets_init', gplwt_register_widgets);
function gplwt_register_widgets(){
	// curl need to be installed
	register_widget('GPLWT_Widget');
}
///////////////////////////////////
class GPLWT_Widget extends WP_Widget {
	function GPLWT_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'gplwt', 'description' => 'This is the GPLWT Plugin Widget.' );
		/* Widget control settings. */
		$control_ops = array( 'width' => 700, 'height' => 500, 'id_base' => 'gplwt-widget' );
		/* Create the widget. */
		$this->WP_Widget( 'gplwt-widget', 'GPLWT Widget', $widget_ops, $control_ops );
	}
	function widget( $args, $instance ) {
		extract( $args );
		//$instance = get_option("widget_getPostListThumbs");
		if (!is_array( $options ))
		{
		$options = array(
			'orient' => '',
			'imgo' => '',
			'ttgo' => '',
			'dtgo' => '',
			'dtfrm' => '',
			'categ' => '',
			'postnr' => '',
			'linn' => '',
			'divwid' => '',
			'tbwid' => '',
			'tbhig'  => '',
			'cp' => '',
			'cs' => '',
			'lwt' => '',
			'tte' => '',
			'sptb' => '',
			'tgtb' => false,
			'ordm'=> '',
			'ordf'=>'ID',
			'metk' =>'',
			'mett' => ''
			 );

		}
	 /*echo $before_widget;
		echo $before_title;
			  echo $options['title'];
			echo $after_title;  
		  echo $after_widget;*/
		  //Our Widget Content
			getPostListThumbs($instance['orient'],$instance['imgo'],$instance['ttgo'],$instance['dtgo'],$instance['dtfrm'],$instance['categ'],$instance['postnr'],$instance['linn'],$instance['divwid'],$instance['tbwid'],$instance['tbhig'],$instance['cp'],$instance['cs'],$instance['lwt'],$instance['tte'],$instance['sptb'],$instance['tgtb'],$instance['ordm'],$instance['$ordf'],$instance['$metk'],$instance['$mett']);
	}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		/* Strip tags (if needed) and update the widget settings. */
		$instance['orient'] = $new_instance['orient'];
		$instance['imgo'] = $new_instance['imgo'];
		$instance['ttgo'] = $new_instance['ttgo'];
		$instance['dtgo'] = $new_instance['dtgo'];
		$instance['dtfrm'] = $new_instance['dtfrm'];
		$instance['categ'] = htmlspecialchars($new_instance['categ']);
		$instance['postnr'] = htmlspecialchars($new_instance['postnr']);
		$instance['linn'] = htmlspecialchars($new_instance['linn']);
		$instance['divwid'] = htmlspecialchars($new_instance['divwid']);
		$instance['tbwid'] = htmlspecialchars($new_instance['tbwid']);
		$instance['tbhig'] = htmlspecialchars($new_instance['tbhig']);
		$instance['cp'] = $new_instance['cp'];
		$instance['cs'] = $new_instance['cs'];
		$instance['lwt'] = $new_instance['lwt'];
		$instance['tte'] = htmlspecialchars($new_instance['tte']);
		$instance['sptb'] = htmlspecialchars($new_instance['sptb']);
		$instance['tgtb'] = htmlspecialchars($new_instance['tgtb']);
		$instance['ordm'] = $new_instance['ordm'];
		$instance['$ordf'] = $new_instance['ordf'];
		$instance['$metk'] = $new_instance['metk'];
		$instance['$mett'] = $new_instance['mett'];
		return $instance;
	}
	function form( $instance ) {
		/* Set up some default widget settings. */
		$defaults = array( 'orient' => 'v',
        'imgo' => false,
        'ttgo' => false,
        'dtgo' => false,
        'dtfrm' => 1,
        'categ' => '',
        'postnr' => 20,
        'linn' => 3,
        'tbwid' => 40,
        'tbhig' => 40,		
		'cp' => 4,
		'cs' => 4,
		'lwt' => 1,
		'tte' => '',
		'sptb' => false,
		'tgtb' => false,
		'ordm'=>'',
		'ordf'=>'ID',
		'metk'=>'',
		'mett'=>'n'
		);
		$instance = wp_parse_args( (array) $instance, $defaults );
?>
        <p>
           <?php
             //          
                if($instance['orient']=="h"){
                    $vchk = "";
                    $hchk = "checked";
                }
                else{
                    $vchk = "checked";
                    $hchk = "";
                }
                //
                if($instance['dtfrm']==2){
                    $d1chk = "";
                    $d2chk = "checked";
                }
                else{
                    $d1chk = "checked";
                    $d2chk = "";
                }
                //
                if($instance['imgo']){
                    $ichk = "checked";
                }
                else{
                    $ichk = "";
                }
                //
                if($instance['ttgo']){
                    $tchk = "checked";
                }
                else{
                    $tchk = "";
                }
                //
                if($instance['dtgo']){
                    $dchk = "checked";
                }
                else{
                    $dchk = "";
                }
                //
                if($instance['lwt']==2){
                    $l1chk = "";
                    $l2chk = "checked";
                }
                else{
                    $l1chk = "checked";
                    $l2chk = "";
                }
                //
                if($instance['sptb']){
                    $schk = "checked";
                }
                else{
                    $schk = "";
                }
                //
                if($instance['tgtb']){
                    $kchk = "checked";
                }
                else{
                    $kchk = "";
                }
				//          
				if($instance['ordm']=="ASC"){
					$omachk = "checked";
					$omdchk = "";
				}
				else{
					$omachk = "";
					$omdchk = "checked";
				}
				//
				$ordfi="";
				$ordfd="";
				$ordft="";
				$ordfr="";
				if($instance['ordf']=="ID"){
					$ordfi="selected";
				}
				if($instance['ordf']=="post_date"){
					$ordfd="selected";
				}
				if($instance['ordf']=="title"){
					$ordft="selected";
				}
				if($instance['ordf']=="random"){
					$ordfr="selected";
				}
				//          
				if($instance['mett']=="t"){
					$mschk = "checked";
					$mnchk = "";
				}
				else{
					$mschk = "";
					$mnchk = "checked";
				}
				//
				//'orient' => 'v','imgo' => false,'ttgo' => false,'dtgo' => false,'dtfrm' => 1,'categ' => '','postnr' => 20,'linn' => 3,'tbwid' => 40,'tbhig' => 40,'cp' => 4,'cs' => 4,'lwt' => 1,'tte' => '','sptb' => false,'tgtb' => false
            ?>
            <label for="<?php echo $this->get_field_id( 'tte' ); ?>">Title: </label><br />
            <input type="text" id="<?php echo $this->get_field_id( 'tte' ); ?>" name="<?php echo $this->get_field_name( 'tte' ); ?>" value="<?php echo $instance['tte'];?>" />
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'orient' ); ?>">Orientation: </label><br />
            <input type="radio" id="<?php echo $this->get_field_id( 'orient' ); ?>" name="<?php echo $this->get_field_name( 'orient' ); ?>" value="v" <?=$vchk?> />Vertical 
            <input type="radio" id="<?php echo $this->get_field_id( 'orient' ); ?>" name="<?php echo $this->get_field_name( 'orient' ); ?>" value="h" <?=$hchk?>/>Horizontal     
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'sptb' ); ?>">Suppress Thumbnails: </label><br />
            <input type="checkbox" id="<?php echo $this->get_field_id( 'sptb' ); ?>" name="<?php echo $this->get_field_name( 'sptb' ); ?>"  <?=$schk?> />
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'imgo' ); ?>">Display only images: </label><br />
            <input type="checkbox" id="<?php echo $this->get_field_id( 'imgo' ); ?>" name="<?php echo $this->get_field_name( 'imgo' ); ?>"  <?=$ichk?> />
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'dtgo' ); ?>">Display post date: </label><br />
            <input type="checkbox" id="<?php echo $this->get_field_id( 'dtgo' ); ?>" name="<?php echo $this->get_field_name( 'dtgo' ); ?>"  <?=$dchk?> />
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'dtfrm' ); ?>">Date Format: </label><br />
            <input type="radio" id="<?php echo $this->get_field_id( 'dtfrm' ); ?>" name="<?php echo $this->get_field_name( 'dtfrm' ); ?>" value="1" <?=$d1chk?>/>d/m/y
            <input type="radio" id="<?php echo $this->get_field_id( 'dtfrm' ); ?>" name="<?php echo $this->get_field_name( 'dtfrm' ); ?>" value="2" <?=$d2chk?> />m/d/y
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'ttgo' ); ?>">Display post title: </label><br />
            <input type="checkbox" id="<?php echo $this->get_field_id( 'ttgo' ); ?>" name="<?php echo $this->get_field_name( 'ttgo' ); ?>"  <?=$tchk?> />
            <br /><br />
            <label for="<?php echo $this->get_field_id( 'categ' ); ?>">Category Name(blank for all categories): </label><br />
            <input type="text" id="<?php echo $this->get_field_id( 'categ' ); ?>" name="<?php echo $this->get_field_name( 'categ' ); ?>" value="<?php echo $instance['categ'];?>" />
            <br /><br />
			<label for="<?php echo $this->get_field_id( 'metk' ); ?>">Custom Field Key: </label><br />
			<input type="text" id="<?php echo $this->get_field_id( 'metk' ); ?>" name="<?php echo $this->get_field_name( 'metk' ); ?>" value="<?php echo $instance['metk'];?>" />
			<br /><br />
			<label for="getPostListThumbs-WidgetMetT">Custom Field Values Type: </label><br />
			<input type="radio" id="<?php echo $this->get_field_id( 'mett' ); ?>" name="<?php echo $this->get_field_name( 'mett' ); ?>" value="n" <?=$mnchk?>/>Numbers
			<input type="radio" id="<?php echo $this->get_field_id( 'mett' ); ?>" name="<?php echo $this->get_field_name( 'mett' ); ?>" value="t" <?=$mschk?> />Text 
			<br /><br />
            <label for="<?php echo $this->get_field_id( 'postnr' ); ?>">Number of Posts(default=20): </label><br />
            <input type="text" id="<?php echo $this->get_field_id( 'postnr' ); ?>" name="<?php echo $this->get_field_name( 'postnr' ); ?>" value="<?php echo $instance['postnr'];?>" size="4"/>
            <br /><br />
			<label for="<?php echo $this->get_field_id( 'ordm' ); ?>">Order: </label><br />
			<input type="radio" id="<?php echo $this->get_field_id( 'ordm' ); ?>" name="<?php echo $this->get_field_name( 'ordm' ); ?>" value="DESC" <?=$omdchk?>/>DESC
			<input type="radio" id="<?php echo $this->get_field_id( 'ordm' ); ?>" name="<?php echo $this->get_field_name( 'ordm' ); ?>" value="ASC" <?=$omachk?> />ASC 
			<br /><br />
			<label for="<?php echo $this->get_field_id( 'ordrf' ); ?>">Order By: </label><br />
			<select id="<?php echo $this->get_field_id( 'ordrf' ); ?>" name="<?php echo $this->get_field_name( 'ordf' ); ?>">
				<option value="ID" <?=$ordfi?>>ID</option>
				<option value="post_date" <?=$ordfd?>>Date</option>
				<option value="title" <?=$ordft?>>Title</option>
				<option value="random" <?=$ordfr?>>Random</option>
			</select>
		   <br /><br />
           <label for="<?php echo $this->get_field_id( 'tgtb' ); ?>">Target links to a blank page/tab: </label><br />
           <input type="checkbox" id="<?php echo $this->get_field_id( 'tgtb' ); ?>" name="<?php echo $this->get_field_name( 'tgtb' ); ?>"  <?=$schk?> />
           <br /><br />
           <label for="<?php echo $this->get_field_id( 'linn' ); ?>">Number of registers per line(default=3 only for horizontal orientation): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'linn' ); ?>" name="<?php echo $this->get_field_name( 'linn' ); ?>" value="<?php echo $instance['linn'];?>" size="4"/>
           <br />
           <label for="<?php echo $this->get_field_id( 'divwid' ); ?>">Result Table Width(default=300): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'divwid' ); ?>" name="<?php echo $this->get_field_name( 'divwid' ); ?>" value="<?php echo $instance['divwid'];?>" size="4"/>
           <br />
           <br />
           <label for="<?php echo $this->get_field_id( 'cp' ); ?>">Result Table Cellpadding(default=4): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'cp' ); ?>" name="<?php echo $this->get_field_name( 'cp' ); ?>" value="<?php echo $instance['cp'];?>" size="4"/>
           <br />
           <label for="<?php echo $this->get_field_id( 'cs' ); ?>">Result Table Cellspacing(default=4): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'cs' ); ?>" name="<?php echo $this->get_field_name( 'cs' ); ?>" value="<?php echo $instance['cs'];?>" size="4"/>
           <br />
           <label for="<?php echo $this->get_field_id( 'tbwid' ); ?>">Thumbnails Width(default=40): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'tbwid' ); ?>" name="<?php echo $this->get_field_name( 'tbwid' ); ?>" value="<?php echo $instance['tbwid'];?>" size="4"/>
           <br />
           <label for="<?php echo $this->get_field_id( 'tbhig' ); ?>">Thumbnails Height(default=40): </label><br />
           <input type="text" id="<?php echo $this->get_field_id( 'tbhig' ); ?>" name="<?php echo $this->get_field_name( 'tbhig' ); ?>" value="<?php echo $instance['tbhig'];?>" size="4"/>
           <br />
           <label for="<?php echo $this->get_field_id( 'dtfrm' ); ?>">Column Layout: </label><br />
           <table cellpadding="0" cellspacing="3">
             <tr>
             <td valign="top"><input type="radio" id="<?php echo $this->get_field_id( 'lwt' ); ?>" name="<?php echo $this->get_field_name( 'lwt' ); ?>" value="1" <?=$l1chk?>/></td><td><table cellpadding="0" cellspacing="3" style="border:0px #666 solid"><tr><td style="border:1px #666 solid">Image</td><td style="border:1px #666 solid"><p>Date</p>Title</td></tr></table></td>
            <td valign="top"><input type="radio" id="<?php echo $this->get_field_id( 'lwt' ); ?>" name="<?php echo $this->get_field_name( 'lwt' ); ?>" value="2" <?=$l2chk?> /></td><td><table cellpadding="0" cellspacing="3" border="1" style="border:0px #666 solid"><tr><td style="border:1px #666 solid">Image</td></tr><tr><td style="border:1px #666 solid"><p>Date</p>Title</td></tr></table></td>
            </tr>
           </table>
            <input type="hidden" id="getPostListThumbs-Submit" name="getPostListThumbs-Submit" value="1" />
          </p>
        <?php
    }
}
?>